#  This file is part of the copd package
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License, or
#  (at your option) any later version.
# 
#  The program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
#  Copyright (C) 2019 Jens Thoms Törring <jt@toerring.de>
#

package Object;
use v5.014;
use strict;
use warnings;


sub new {
	my $class = shift;
	my $self = {@_};
	bless $self, $class;

	# Create getter methods (unless they already exist)

	no strict 'refs';
	for my $attr (keys %$self) {
		next if $self->can($attr);
		*{$class . '::' . $attr} = sub {shift->{$attr}};
	}

	return $self;
}


1;
